#include "Assembly.h"
#include "Load.h"
#include <stdexcept>

Assembly::Assembly(const string &name) : Component(name)
{
	// TODO Auto-generated constructor stub

}

Assembly::~Assembly()
{
	// TODO Auto-generated destructor stub
}

void Assembly::addComponent(Component *comp)
{
	if(comp==NULL)
	{
		throw new logic_error("Nullpointer cannot be added!");
	}
	else
	{
		m_List.push_back(comp);
	}
}

ComponentList::size_type Assembly::removeComponent(Component *comp)
{
	ComponentList::size_type tmpOldSize = m_List.size();

	if(comp==NULL)
	{
		m_List.clear(); //komplette Liste lschen
	}
	else
	{
		m_List.remove(comp); //Element lschen
	}

	return (tmpOldSize - m_List.size());
}

long double Assembly::consumption() const
{
	double allConsump = 0.0;

	for(ComponentList::const_iterator it=m_List.begin(); it!= m_List.end() ; it++)
	{
		allConsump += (*it)->consumption();
	}

	return allConsump;
}

void Assembly::collectAllLoads(Component::Collection &coll)
{
	for(ComponentList::const_iterator it=m_List.begin(); it!= m_List.end() ; it++)
	{
		(*it)->collectAllLoads(coll);
	}
}
