#ifndef ASSEMBLY_H_
#define ASSEMBLY_H_

#include "Component.h"
#include "Load.h"
#include <list>
typedef std::list<Component *> ComponentList;

class Assembly: public Component
{
public:
	Assembly(const string &name);
	void addComponent(Component *comp);
	ComponentList::size_type removeComponent(Component *comp);
	long double consumption() const;
	void collectAllLoads(Component::Collection &coll);
	virtual ~Assembly();

private:
	ComponentList m_List;
};

#endif /* ASSEMBLY_H_ */
