#include "Load.h"
#include <stdexcept>
#include <iostream>

Load::Load(const string &compName, long double powerOut, long double efficiency):
Component(compName), m_dPowerOut(powerOut), m_dEfficiency(efficiency)
{
	// TODO Auto-generated constructor stub

}

long double Load::getPowerOut() const
{
	return m_dPowerOut;
}

long double Load::getEfficiency() const
{
	return m_dEfficiency;
}

long double Load::consumption() const
{
	long double consump;

	if(m_dEfficiency == 0.0)
	{
		throw new logic_error("Efficiency must not be 0.");
	}
	else
	{
		consump = m_dPowerOut/m_dEfficiency;
	}

	return consump;
}
void Load::collectAllLoads(Component::Collection &coll)
{
	coll.push_back(this);
}

bool operator<(const Load &first, const Load &second)
{
	return (first.consumption() < second.consumption());
}

ostream &operator<<(ostream &out, const Component::Collection &coll)
{
	for(Component::Collection::const_iterator it=coll.begin(); it!= coll.end() ; it++)
	{
		out<< (*it)->getName() << " : " << (*it)->consumption() << endl;
	}

	return out;
}


Load::~Load()
{
	// TODO Auto-generated destructor stub
}

