#include <typeinfo>
#include <iostream>
#include "Load2.h"

LoadSet transferCollection(const Component::Collection &coll)
{
	LoadSet mySet;
	for(Component::Collection::const_iterator it=coll.begin(); it!= coll.end(); it++)
	{
		try
		{
			mySet.insert(dynamic_cast<const Load &>(*(*it)));
		}
		catch (const bad_cast& e)
		{
			cerr << e.what();
		}

	}
	return mySet;
}

ostream &operator<<(ostream &out, const LoadSet &set)
{
	for(LoadSet::iterator it=set.begin(); it!= set.end() ; it++)
	{
		out<< (*it).getName() << " : " << (*it).consumption() << endl;
	}

	return out;
}
